-- 
-- Created by SQL::Translator::Producer::SQLite
-- Created on Tue Dec 19 17:23:52 2017
-- 

BEGIN TRANSACTION;

--
-- Table: "ib_access"
--
CREATE TABLE "ib_access" (
  -- Номер группы
  "gid" smallint(6) NOT NULL,
  -- Раздел
  "fid" smallint(5) NOT NULL,
  -- Просмотр раздела, возможность видеть его в списке на главной
  "view" enum(1) NOT NULL DEFAULT '1',
  -- Чтение сообщений в разделе
  "read" enum(1) NOT NULL DEFAULT '1',
  -- Отправка сообщений
  "post" enum(1) NOT NULL DEFAULT '1',
  -- Прикрепление файлов
  "attach" enum(1) NOT NULL DEFAULT '1',
  -- Создание тем
  "topic" enum(1) NOT NULL DEFAULT '1',
  -- Создание опросов
  "poll" enum(1) NOT NULL DEFAULT '1',
  -- Использование HTML-кода без экранирования
  "html" enum(1) NOT NULL DEFAULT '0',
  -- Разрешено ли голосовать в опросах в разделе
  "vote" enum(1) NOT NULL DEFAULT '0',
  -- Разрешено ли рейтинговать сообщения в разделе
  "rate" enum(1) NOT NULL DEFAULT '0',
  -- Возможность редактировать свои сообщения
  "edit" enum(1) NOT NULL DEFAULT '1',
  -- Возможность отправлять сообщения без ввода CAPTCHA
  "nocaptcha" enum(1) NOT NULL DEFAULT '1',
  -- Разрешено ли отправлять сообщения без премодерации
  "nopremod" enum(1) NOT NULL DEFAULT '1',
  PRIMARY KEY ("gid", "fid")
);

--
-- Table: "ib_banned_ip"
--
CREATE TABLE "ib_banned_ip" (
  "start" int(10) NOT NULL,
  "end" int(10) NOT NULL,
  "till" int(10) NOT NULL,
  PRIMARY KEY ("start", "end", "till")
);

--
-- Table: "ib_bots"
--
CREATE TABLE "ib_bots" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Часть строки User Agent, по которой определяется бот
  "user_agent" varchar(255) NOT NULL,
  -- Название бота (выводится в админке и списке присутствующих)
  "bot_name" varchar(255) NOT NULL,
  -- Время последнего визита
  "last_visit" int(10) NOT NULL
);

--
-- Table: "ib_captcha"
--
CREATE TABLE "ib_captcha" (
-- Comments: 
-- Коды CAPTCHA для соответствующего модуля
--

  -- Хеш, по которому осуществляется проверка кода (он же совпадает с именем файла в files/captcha/хеш.jpg)
  "hash" char(32) NOT NULL,
  -- Код, который должен ввести пользователь
  "code" char(8) NOT NULL,
  -- Признак того, что данный код еще не использован
  "active" enum(1) NOT NULL DEFAULT '1',
  -- Время генерации пары хеш-код (нужно для удаления устаревших пар)
  "lastmod" int(11) NOT NULL,
  -- IP адрес пользователя, запросившего хеш (возможно, будет использоваться для блокировки)
  "ip" int(11) NOT NULL,
  PRIMARY KEY ("hash")
);

CREATE INDEX "lastmod" ON "ib_captcha" ("lastmod");

--
-- Table: "ib_category"
--
CREATE TABLE "ib_category" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Название категории
  "title" varchar(80) NOT NULL,
  -- Если 1, то по умолчанию на главной выводится в свернутом виде
  "collapsed" enum(1) NOT NULL DEFAULT '0',
  "sortfield" smallint(5) NOT NULL
);

--
-- Table: "ib_complain"
--
CREATE TABLE "ib_complain" (
-- Comments: 
-- Жалобы пользователей на сообщения
--

  -- Номер жалобы
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Идентификатор пользователя, ее отправившего
  "uid" mediumint(8) DEFAULT 0,
  -- Идентификатор сообщения, на которое подана жалоба
  "pid" int(10) DEFAULT 0,
  -- Жалоба обработана
  "processed" enum(1) DEFAULT '0',
  -- Модератор, выполнивший обработку
  "moderator" mediumint(8) DEFAULT 0,
  -- Текст жалобы
  "text" varchar(255) DEFAULT NULL,
  -- Комментарий модератора
  "mod_comment" varchar(255) DEFAULT NULL
);

--
-- Table: "ib_crontab"
--
CREATE TABLE "ib_crontab" (
-- Comments: 
-- Список заданий, выполняемых по времени
--

  -- Идентификатор задания
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Библиотека, в которой находится выполняемая процедура
  "library" varchar(24) NOT NULL,
  -- Название процедуры
  "proc" varchar(255) NOT NULL,
  -- Параметры процедуры
  "params" varchar(255) NOT NULL,
  -- Описание (показывается администраторам сайта)
  "description" varchar(255) NOT NULL,
  -- Время след. выполнения
  "nextrun" int(11) NOT NULL,
  -- Период выполнения (в минутах), если равен нулю, задание отключено
  "period" smallint(6) NOT NULL
);

CREATE INDEX "nextrun" ON "ib_crontab" ("nextrun", "period");

--
-- Table: "ib_file"
--
CREATE TABLE "ib_file" (
-- Comments: 
-- Приложенные файлы
--

  -- Ключ-идентификатор файла
  "fkey" char(16) NOT NULL DEFAULT '',
  -- Номер объекта, к которому прикреплен файл
  "oid" int(11) NOT NULL,
  -- Тип прикрепления: 1 -- к форумному сообщению, 2 -- к ЛС (не используется)
  "type" tinyint(16) NOT NULL,
  -- Имя файла при скачивании
  "filename" varchar(255) NOT NULL,
  -- Размер файла
  "size" int(11) NOT NULL,
  "format" enum(6) NOT NULL DEFAULT 'attach',
  "extension" char(4) NOT NULL,
  PRIMARY KEY ("fkey")
);

CREATE INDEX "oid" ON "ib_file" ("oid", "type");

--
-- Table: "ib_forum"
--
CREATE TABLE "ib_forum" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Модуль, отвечающий за показ страницы
  "module" varchar(16) NOT NULL,
  -- Название раздела
  "title" varchar(80) NOT NULL,
  -- Описание раздела
  "descr" varchar(255) NOT NULL DEFAULT '',
  -- Частичный URL
  "hurl" varchar(255) NOT NULL,
  "category_id" smallint(5) NOT NULL DEFAULT 0,
  -- Родительский раздел
  "parent_id" smallint(5) NOT NULL DEFAULT 0,
  -- Владелец раздела (для личных блогов, галерей и т.п.)
  "owner" mediumint(9) NOT NULL DEFAULT 0,
  -- Порядок сортировки
  "sortfield" smallint(5) NOT NULL DEFAULT 0,
  -- Форум закрыт для новых сообщений: 0 -- нет, 1 -- да
  "locked" enum(1) NOT NULL DEFAULT '0',
  -- Дата последнего изменения
  "lastmod" int(10) NOT NULL DEFAULT 0,
  -- Id последнего сообщения
  "last_post_id" int(10) NOT NULL DEFAULT 0,
  -- Шаблон для отображения раздела
  "template" varchar(32) NOT NULL DEFAULT '',
  -- Приоритет шаблона форума над шаблоном пользователя
  "template_override" enum(1) NOT NULL DEFAULT '0',
  -- Использование BBCode
  "bcode" enum(1) NOT NULL DEFAULT '1',
  -- Максимальное количество смайликов в сообщении
  "max_smiles" tinyint(3) NOT NULL DEFAULT 16,
  -- Максимальное количество файлов, которое можно прикрепить к сообщению
  "max_attach" tinyint(3) NOT NULL DEFAULT 0,
  -- Допустимые типы прикрепляемых файлов. Указываются как битовая маска: 255 -- все, 1 -- картинки, 2 -- видео, 4 -- аудио, 8 -- текст, 128 -- все остальное
  "attach_types" tinyint(3) NOT NULL DEFAULT 255,
  -- Количество видимых тем (т.е. со статусом "0", без учета стоящих на премодерации и удаленных)
  "topic_count" mediumint(8) NOT NULL DEFAULT 0,
  -- Количество видимых сообщений
  "post_count" int(10) NOT NULL DEFAULT 0,
  -- Является ли раздел статистически значимым
  "is_stats" enum(1) NOT NULL DEFAULT '1',
  -- Является ли флуд-разделом (не показывать в "Обновившихся" и "Непрочитанных", а так же поиске, если он не включен явно)
  "is_flood" enum(1) NOT NULL DEFAULT '0',
  -- Показывать ли раздел на главной странице
  "is_start" enum(1) NOT NULL DEFAULT '1',
  -- Имя файла при наличии новых сообщений
  "icon_new" varchar(255) NOT NULL DEFAULT '',
  -- Имя файла при отсутствии новых сообщений
  "icon_nonew" varchar(255) NOT NULL DEFAULT '',
  -- Порядок сортировки тем в разделе по умолчанию: по возрастанию или убыванию
  "sort_mode" enum(4) NOT NULL DEFAULT 'DESC',
  -- Способ сортировки тем в форуме по умолчанию: по дате последнего сообщения или дате создания
  "sort_column" enum(14) NOT NULL DEFAULT 'last_post_time',
  -- Опросы в темах: 0 -- отключены вообще, 1 -- разрешены, 2 -- рарешены уже созданные, но запрещено создание новых
  "polls" enum(1) NOT NULL DEFAULT '1',
  -- Самомодерация темы ее создателем
  "selfmod" enum(1) NOT NULL DEFAULT '0',
  -- Первое сообщение является приклееным (выводится на всех страницах): 0 -- нет, 1 -- выставляется модераторами, 2 -- выставлеяется пользователем при создании темы, 3 -- есть всегда
  "sticky_post" enum(1) NOT NULL DEFAULT '2',
  -- Разрешены ли рейтинги на форуме: 0 - нет, 1 -- да, 2 -- только положительные
  "rate" enum(1) NOT NULL DEFAULT '2',
  -- Количество голосов "за", после которых сообщение становится ценным
  "rate_value" float(8,2) NOT NULL DEFAULT 0,
  -- Количество голосов против, после которых сообщение становится флудом
  "rate_flood" float(8,2) NOT NULL DEFAULT 0,
  -- Использование тегов для тем: 0 -- нет, 1 -- да, 2 -- ставить теги могут только модераторы
  "tags" enum(1) NOT NULL DEFAULT '0'
);

CREATE INDEX "sortkey" ON "ib_forum" ("sortfield");

CREATE INDEX "hurl" ON "ib_forum" ("hurl");

--
-- Table: "ib_forum_type"
--
CREATE TABLE "ib_forum_type" (
-- Comments: 
-- Описание типов разделов
--

  -- Имя модуля, который отвечает за отображение раздела
  "module" varchar(40) NOT NULL,
  -- Название раздела для вывода в админке
  "typename" varchar(255) NOT NULL,
  -- У раздела могут быть правила
  "has_rules" enum(1) NOT NULL DEFAULT '1',
  -- У раздела может быть вводное слово
  "has_foreword" enum(1) NOT NULL DEFAULT '1',
  -- Над данным типом разделов разрешены групповые операции
  "allow_mass" enum(1) NOT NULL DEFAULT '1',
  -- У разделов данного типа могут быть вложенные подразделы
  "allow_subforums" enum(1) NOT NULL DEFAULT '0',
  -- Разделы данного типа могут быть личными
  "allow_personal" enum(1) NOT NULL DEFAULT '0',
  -- Поле для сортировки
  "sortfield" smallint(5) NOT NULL DEFAULT 1,
  -- Шаблон для генерации правил для файла .htaccess
  "htaccess" text,
  PRIMARY KEY ("module")
);

--
-- Table: "ib_group"
--
CREATE TABLE "ib_group" (
  -- Номер группы, он же уровень доступа. В целом рекомендуется так: чем выше, тем статуснее группа
  "level" INTEGER PRIMARY KEY NOT NULL,
  "name" varchar(32) NOT NULL,
  -- В особые группы пользователь может быть добавлен только явно, администратором
  "special" enum(1) NOT NULL DEFAULT '1',
  "floodtime" smallint(5) NOT NULL DEFAULT 60,
  "privmsg_hour" tinyint(3) NOT NULL DEFAULT 240,
  -- Макс размер приложенного файла (в килобайтах)
  "max_attach" smallint(5) NOT NULL,
  -- Минимальное число сообщений
  "min_posts" smallint(5) NOT NULL DEFAULT 0,
  -- Разрешено пользователю ставить себе "особое звание"
  "custom_title" enum(1) NOT NULL DEFAULT '0',
  -- Является ли группа администраторами
  "admin" enum(1) NOT NULL DEFAULT '0',
  -- Группа считается группой команды форума (из групп команды назначаются модераторы и эксперты форума, ее участники выводятся в списке "наша команда")
  "team" enum(1) NOT NULL DEFAULT '0',
  -- Founder -- права суперпользователя форума (администратор с правом назначения/снятия других администраторов и сменой глобальных настроек)
  "founder" enum(1) NOT NULL DEFAULT '0',
  -- Количество дней, которое должно пройти с момента регистрации, для получения уровня (если уровень -- не "особый"
  "min_reg_time" smallint(5) NOT NULL DEFAULT 0,
  -- Режим использования гиперссылок:  none -- запрещено отправлять сообщения со ссылками, premoderate -- сообщения со ссылками уходят на премодерацию, nofollow -- ссылкам ставится аттрибут nofollow, allow -- ссылки выводятся нормально
  "links_mode" enum(8) NOT NULL DEFAULT 'allow'
);

--
-- Table: "ib_last_visit"
--
CREATE TABLE "ib_last_visit" (
-- Comments: 
-- Данные о посещении раздела или темы пользователем
--

  -- Идентификатор раздела или темы
  "oid" mediumint(9) NOT NULL,
  -- Тип объекта: раздел или тема
  "type" enum(5) NOT NULL,
  -- Идентификатор пользователя
  "uid" mediumint(9) NOT NULL,
  -- Время текущего посещения
  "visit1" int(11) NOT NULL,
  -- Время предыдущего посещения
  "visit2" int(11) NOT NULL,
  -- Находится ли тема в закладках
  "bookmark" enum(1) NOT NULL DEFAULT '0',
  -- Подписан ли пользователь на тему (0 -- нет, 1 -- отправка уведомлений сразу, 2 -- уведомление только о первом новом сообщении, 3 и более -- периодическая высылка уведомлений)
  "subscribe" tinyint(4) NOT NULL DEFAULT 0,
  -- Дата последней отправки сообщения
  "lastmail" int(11) NOT NULL,
  -- Если пользователь писал в эту тему
  "posted" enum(1) NOT NULL DEFAULT '0',
  PRIMARY KEY ("oid", "uid", "type")
);

--
-- Table: "ib_log_action"
--
CREATE TABLE "ib_log_action" (
-- Comments: 
-- Лог модераторских действий с возможностью отката измеений
--

  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Номер сообщения, над которым совершалось действие
  "pid" int(10) NOT NULL DEFAULT 0,
  -- Номер темы, над которой совершалось действие
  "tid" mediumint(8) NOT NULL DEFAULT 0,
  -- Номер раздела, над которым совершалось действие
  "fid" mediumint(8) NOT NULL DEFAULT 0,
  -- Тип модераторского действия
  "type" tinyint(3) NOT NULL,
  -- Время модераторского действия
  "time" int(10) NOT NULL,
  -- Модератор или пользователь, выполнивший действие
  "uid" mediumint(8) NOT NULL,
  -- Данные для отката модераторского действия
  "data" text NOT NULL
);

--
-- Table: "ib_mark_all"
--
CREATE TABLE "ib_mark_all" (
-- Comments: 
-- Данные об отметке раздела или всего форума как прочтенного
--

  -- Идентификатор пользователя
  "uid" mediumint(8) NOT NULL,
  -- Раздел, для которого выполняется действие "Отметить все" (0 -- весь форум)
  "fid" mediumint(8) NOT NULL,
  -- Время выполнения действия
  "mark_time" int(10) NOT NULL,
  PRIMARY KEY ("uid", "fid")
);

--
-- Table: "ib_menu"
--
CREATE TABLE "ib_menu" (
-- Comments: 
-- Список различных меню, используемых движком
--

  -- Идентификатор меню
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Описание меню (показывается в админцентре)
  "descr" varchar(255) NOT NULL,
  -- Запрет на удаление меню (для наиболее важных системных меню)
  "locked" enum(1) NOT NULL
);

--
-- Table: "ib_menu_item"
--
CREATE TABLE "ib_menu_item" (
-- Comments: 
-- Элементы меню
--

  -- Идентификатор пункта
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Идентификатор меню, которому принадлежит пункт
  "mid" smallint(6) NOT NULL,
  -- Заголовок пункта меню (выводится при выводе меню)
  "title" varchar(255) NOT NULL,
  -- URL пункта меню
  "url" varchar(255) NOT NULL,
  -- Поле для определения порядка сортировки
  "sortfield" smallint(6) NOT NULL,
  -- Показывать пункт гостям
  "show_guests" enum(1) NOT NULL DEFAULT '0',
  -- Показывать пункт пользователям
  "show_users" enum(1) NOT NULL DEFAULT '0',
  -- Показывать пункт администраторам
  "show_admins" enum(1) NOT NULL DEFAULT '0',
  -- Является ли ссылка адресом относительно корня форума (нужно ли применять функцию url)
  "hurl_mode" enum(1) NOT NULL DEFAULT '0'
);

CREATE INDEX "mid" ON "ib_menu_item" ("mid", "sortfield");

--
-- Table: "ib_moderator"
--
CREATE TABLE "ib_moderator" (
-- Comments: 
-- Данные о модераторах и экспертах форума
--

  -- Объект, для которого пользователь показывается как член команды
  "fid" mediumint(9) NOT NULL,
  -- Идентификатор пользователя
  "uid" mediumint(9) NOT NULL,
  -- Роль (модератор или эксперт)
  "role" enum(9) NOT NULL,
  PRIMARY KEY ("fid", "uid", "role")
);

--
-- Table: "ib_online"
--
CREATE TABLE "ib_online" (
  -- Идентификатор пользователя
  "uid" mediumint(8) NOT NULL,
  -- Хеш данных пользователя (IP-адрес, user agent и еще несколько полей заголовков HTTP)
  "hash" char(32) NOT NULL,
  -- Время последнего визита
  "visittime" int(10) NOT NULL,
  -- Тип пользователя (0 -- гость, -1 -- зарегистрированный пользователь, -2 -- член команды, положительные значения -- номера ботов
  "type" smallint(6) NOT NULL,
  -- Номер раздела, над которым совершается действие
  "fid" mediumint(8) NOT NULL,
  -- Номер темы
  "tid" mediumint(8) NOT NULL,
  -- Описание действия, обрабатыавется через sprintf с подстановкой ссылок на тему и форум
  "text" varchar(255) NOT NULL,
  -- IP пользователя (подумать, нужен ли вообще)
  "ip" int(10) NOT NULL,
  PRIMARY KEY ("hash")
);

CREATE INDEX "uid" ON "ib_online" ("uid");

--
-- Table: "ib_poll"
--
CREATE TABLE "ib_poll" (
-- Comments: 
-- Таблица опросов
--

  -- Тема, к которой привязан опрос
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Текст вопроса
  "question" varchar(255) NOT NULL,
  -- Дата окончания опроса
  "endtime" int(10) NOT NULL,
  -- Режим голосования: 0 -- анонимный, 1 -- с возможностью просмотра проголосовавших (пока не используется)
  "mode" enum(1) NOT NULL DEFAULT '0',
  -- Количество вариантов ответов, которое можно выбрать (пока не используется)
  "max_variants" tinyint(4) NOT NULL DEFAULT 1
);

--
-- Table: "ib_poll_variant"
--
CREATE TABLE "ib_poll_variant" (
  -- Идентификатор варианта ответа
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Идентификатор темы с голосованием
  "tid" mediumint(8) NOT NULL,
  -- Текст варианта ответа
  "text" varchar(80) NOT NULL,
  -- Количество голосований за этот вариант
  "count" mediumint(8) NOT NULL DEFAULT 0
);

CREATE INDEX "poll_tid" ON "ib_poll_variant" ("tid");

--
-- Table: "ib_post"
--
CREATE TABLE "ib_post" (
-- Comments: 
-- Данные о сообщениях в темах и разделах
--

  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Тема, к которой относится сообщение
  "tid" mediumint(9) NOT NULL,
  -- Номер владельца сообщения
  "uid" mediumint(9) NOT NULL DEFAULT 1,
  -- Автор сообщения (NULL -- если зарегистрированный пользователь)
  "author" varchar(64) NOT NULL DEFAULT 'Guest',
  -- Дата отправки сообщения
  "postdate" int(11) NOT NULL DEFAULT 0,
  -- Количество редактирований
  "editcount" smallint(6) NOT NULL DEFAULT 0,
  -- Идентификатор последнего отредактировавшего сообщение
  "editor_id" mediumint(8) NOT NULL DEFAULT 0,
  -- Ценность сообщения: 0 -- обычное, 1 -- ценное, -1 -- флуд
  "value" enum(2) NOT NULL DEFAULT '0',
  -- Статус сообщения: 0 -- нормальное сообщение, 1 -- на премодерации, 2 -- удалено
  "status" enum(1) NOT NULL DEFAULT '0',
  -- Сообщение заблокировано от редактирования
  "locked" enum(1) NOT NULL DEFAULT '0',
  -- В сообщении разрешено использование HTML
  "html" enum(1) NOT NULL DEFAULT '0',
  -- В сообщении разрешено использование BoardCode
  "bcode" enum(1) NOT NULL DEFAULT '1',
  -- В сообщении разрешены графические смайлики
  "smiles" enum(1) NOT NULL DEFAULT '1',
  -- Автоматически обрабатывать ссылки
  "links" enum(1) NOT NULL DEFAULT '1',
  -- Автоматически типографировать сообщение
  "typograf" enum(1) NOT NULL DEFAULT '1',
  -- Рейтинг сообщения
  "rating" float(8,2) NOT NULL DEFAULT 0,
  -- IP, с которого было отправлено сообщение
  "ip" int(11) NOT NULL
);

CREATE INDEX "topic" ON "ib_post" ("tid", "postdate");

CREATE INDEX "author_uid" ON "ib_post" ("uid");

--
-- Table: "ib_privmsg_link"
--
CREATE TABLE "ib_privmsg_link" (
-- Comments: 
-- Связь сообщений в теме и пользователей, у которых их видно
--

  "pm_id" int(11) NOT NULL,
  "uid" mediumint(9) NOT NULL,
  PRIMARY KEY ("uid", "pm_id")
);

--
-- Table: "ib_privmsg_post"
--
CREATE TABLE "ib_privmsg_post" (
-- Comments: 
-- Личные сообщения 
--

  "id" INTEGER PRIMARY KEY NOT NULL,
  "pm_thread" int(10) NOT NULL,
  -- Количество получателей сообщения
  "subscribers" tinyint(3) DEFAULT 1,
  "uid" mediumint(8) NOT NULL,
  "text" text NOT NULL,
  "postdate" int(10) NOT NULL,
  "html" enum(1) NOT NULL DEFAULT '0',
  "bcode" enum(1) NOT NULL DEFAULT '1',
  "smiles" enum(1) NOT NULL DEFAULT '1',
  "links" enum(1) NOT NULL DEFAULT '1',
  "typograf" enum(1) NOT NULL DEFAULT '1'
);

CREATE INDEX "thread" ON "ib_privmsg_post" ("pm_thread", "postdate");

--
-- Table: "ib_privmsg_thread"
--
CREATE TABLE "ib_privmsg_thread" (
-- Comments: 
-- Таблица тем ЛС.
--

  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Название темы ЛС
  "title" varchar(255) NOT NULL
);

--
-- Table: "ib_privmsg_thread_user"
--
CREATE TABLE "ib_privmsg_thread_user" (
-- Comments: 
-- Данные о теме, специфичные для пользователя
--

  "pm_thread" int(11) NOT NULL,
  "uid" mediumint(9) NOT NULL,
  -- Количество доступных сообщений
  "total" smallint(6) NOT NULL DEFAULT 0,
  -- Количество непрочитанных сообщений
  "unread" smallint(6) NOT NULL DEFAULT 0,
  -- Идентификатор последнего доступного пользователю сообщения
  "last_post_date" int(10) NOT NULL DEFAULT 0,
  PRIMARY KEY ("uid", "pm_thread")
);

--
-- Table: "ib_rating"
--
CREATE TABLE "ib_rating" (
-- Comments: 
-- Информация о том, когда было отрейтинговано сообщение
--

  "id" int(10) NOT NULL,
  "uid" mediumint(8) NOT NULL,
  "value" float(8,2) NOT NULL,
  "time" int(10) NOT NULL,
  "ip" int(10) NOT NULL,
  PRIMARY KEY ("id", "uid")
);

--
-- Table: "ib_relation"
--
CREATE TABLE "ib_relation" (
  "from" mediumint(8) NOT NULL,
  "to" mediumint(8) NOT NULL,
  "type" enum(6) NOT NULL,
  PRIMARY KEY ("from", "to")
);

--
-- Table: "ib_search"
--
CREATE TABLE "ib_search" (
-- Comments: 
-- Таблица для хранения результатов поиска FULLTEXT или Sphynx
--

  -- Номер поиска
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Id ищущего пользователя
  "owner" mediumint(8) DEFAULT 0,
  -- Режим вывода (темы или сообщения)
  "output_mode" enum(6) DEFAULT 'posts',
  -- Режим поиска (для выдачи информации о запросе при его показе)
  "search_type" tinyint(4) DEFAULT 1,
  -- Текст запроса
  "query" varchar(255) DEFAULT '1',
  -- Время запроса
  "time" int(10) DEFAULT NULL,
  -- Расширенные данные поиска: дата, время, разделы
  "extdata" text
);

--
-- Table: "ib_search_result"
--
CREATE TABLE "ib_search_result" (
-- Comments: 
-- Таблица для хранения результатов поиска
--

  -- Номер поиска
  "sid" int(10) NOT NULL,
  -- Номер найденного сообщения или темы
  "oid" int(10) NOT NULL,
  -- Релевантность сообщения (или значение для сортировки)
  "relevancy" float(8,2) DEFAULT 0,
  PRIMARY KEY ("oid", "sid")
);

CREATE INDEX "relevancy" ON "ib_search_result" ("sid", "relevancy");

--
-- Table: "ib_smile"
--
CREATE TABLE "ib_smile" (
  -- Код смайлика
  "code" varchar(16) NOT NULL,
  -- Имя файла со смайликом
  "file" varchar(255) NOT NULL,
  -- Описание того, что смайлик обозначает
  "descr" varchar(255) NOT NULL,
  -- Режим отображения смайлика в панели редактора: more -- обычный, dropdown -- в выпадающем списке, hidden -- не отображать
  "mode" enum(8) NOT NULL DEFAULT 'dropdown',
  -- Поле для сортировки
  "sortfield" smallint(5) NOT NULL DEFAULT 0,
  PRIMARY KEY ("code")
);

--
-- Table: "ib_subactions"
--
CREATE TABLE "ib_subactions" (
-- Comments: 
-- Вспомогательные действия (пока не используется)
--

  -- Имя модуля. Может содержать одно из зарезервированных ключевых слов: All (все модули), Forum (модуль форумного типа в режиме показа раздела), Topic (модуль форумного типа в режиме показа темы)
  "module" varbinary(24) NOT NULL DEFAULT '''All''',
  -- Имя основного действия, при котором выполняется данное вспомогательное. Может быть *, если нужно выполнить для всех действий.
  "action" varbinary(32) NOT NULL DEFAULT '*',
  -- Имя библиотеки, в которой лежит обработчик вспомогательного действия
  "library" varbinary(24) NOT NULL,
  -- Имя функции в библиотеке, реализующей данное действие
  "function" varbinary(32) NOT NULL,
  -- Признак того, что действие включено и должно выполняться
  "active" enum(1) NOT NULL DEFAULT '1',
  -- Параметры, передаваемые в функцию
  "params" varchar(255) NOT NULL,
  -- Приоритет по умолчанию (более высокие выполняются первыми)
  "priority" smallint(6) NOT NULL DEFAULT 0,
  PRIMARY KEY ("module", "action")
);

--
-- Table: "ib_tagentry"
--
CREATE TABLE "ib_tagentry" (
  "tag_id" smallint(6) NOT NULL,
  "item_id" mediumint(9) NOT NULL,
  PRIMARY KEY ("tag_id", "item_id")
);

--
-- Table: "ib_tagname"
--
CREATE TABLE "ib_tagname" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  "type" enum(5) NOT NULL,
  "tagname" varchar(32) NOT NULL,
  "count" mediumint(9) DEFAULT NULL
);

CREATE UNIQUE INDEX "tagname" ON "ib_tagname" ("tagname", "type");

--
-- Table: "ib_text"
--
CREATE TABLE "ib_text" (
  -- Номер раздела
  "id" mediumint(8) NOT NULL,
  -- Тип текста: 0 -- правила, 1 -- объявление, 2 -- текст статического раздела
  "type" tinyint(3) NOT NULL,
  -- Текст
  "data" mediumtext(16777215) NOT NULL,
  "tx_lastmod" int(10) NOT NULL DEFAULT 0,
  PRIMARY KEY ("id", "type")
);

CREATE INDEX "search" ON "ib_text" ("data");

--
-- Table: "ib_timeout"
--
CREATE TABLE "ib_timeout" (
-- Comments: 
-- Таблица хранения таймаутов между действиями (типа регистраци
--

  -- Время последней попытки совершения действия
  "time" int(11) NOT NULL,
  -- Условное название действия
  "action" varchar(32) NOT NULL,
  -- Идентификатор пользователя
  "uid" mediumint(9) NOT NULL,
  "ip" int(11) NOT NULL
);

CREATE INDEX "time" ON "ib_timeout" ("time", "action", "uid");

--
-- Table: "ib_topic"
--
CREATE TABLE "ib_topic" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Идентификатор раздела, в котором находится тема
  "fid" mediumint(8) NOT NULL,
  -- Название темы
  "title" varchar(80) NOT NULL,
  -- Описание темы
  "descr" varchar(255) NOT NULL,
  -- Статус темы: 0 -- нормальная, 1 -- на премодерации, 2 -- удалена
  "status" enum(1) NOT NULL DEFAULT '0',
  -- HURL темы (без HURL раздела)
  "hurl" varchar(255) NOT NULL DEFAULT '',
  -- Тема закрыта
  "locked" enum(1) NOT NULL DEFAULT '0',
  -- Первое сообщение темы
  "first_post_id" int(10) NOT NULL DEFAULT 0,
  -- Второе сообщение темы
  "last_post_id" int(10) NOT NULL DEFAULT 0,
  -- Время последнего изменения темы (отправки сообщения, редактирования или модерации)
  "lastmod" int(10) NOT NULL,
  -- Отображаемое количество сообщений
  "post_count" smallint(5) NOT NULL DEFAULT 0,
  -- Количество сообщений, помеченных как флуд
  "flood_count" smallint(5) NOT NULL DEFAULT 0,
  -- Количество ценных сообщений
  "valued_count" smallint(5) NOT NULL DEFAULT 0,
  -- Владелец темы (обычно автор первого сообщения)
  "owner" mediumint(8) NOT NULL DEFAULT 0,
  -- Тема является прикленной
  "sticky" enum(1) NOT NULL DEFAULT '0',
  -- Показывать ли первое сообщение темы на каждой странице
  "sticky_post" enum(1) NOT NULL DEFAULT '0',
  -- Тема есть в "лучших темах форума"
  "favorites" enum(1) NOT NULL DEFAULT '0',
  -- Расширенный статус (используется специализированными разделами)
  "ext_status" int(10) NOT NULL DEFAULT 0,
  -- Время отправки последнего сообщения (сделано в целях оптимизации нагрузки на БД)
  "last_post_time" int(10) NOT NULL DEFAULT 0,
  -- Суммарный рейтинг темы
  "rating" mediumint(8) NOT NULL DEFAULT 0
);

CREATE INDEX "forum" ON "ib_topic" ("fid", "last_post_id");

CREATE INDEX "Fulltext_title" ON "ib_topic" ("title");

CREATE INDEX "Fulltext_descr" ON "ib_topic" ("descr");

--
-- Table: "ib_user"
--
CREATE TABLE "ib_user" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  "login" varchar(32) NOT NULL,
  "password" varchar(255) NOT NULL,
  "pass_crypt" tinyint(3) NOT NULL,
  "title" varchar(80) NOT NULL,
  "gender" enum(1) NOT NULL DEFAULT 'U',
  "birthdate" date DEFAULT NULL,
  "location" varchar(80) NOT NULL,
  "status" tinyint(3) NOT NULL DEFAULT 0,
  "canonical" varchar(255) NOT NULL,
  "signature" varchar(255) NOT NULL,
  "rnd" int(10) NOT NULL,
  "display_name" varchar(32) NOT NULL,
  "avatar" enum(4) NOT NULL DEFAULT 'none',
  "photo" enum(4) NOT NULL DEFAULT 'none',
  "email" varchar(255) NOT NULL,
  -- Реальное имя пользователя, если он захочет его указать
  "real_name" varchar(255) NOT NULL DEFAULT ''
);

CREATE INDEX "location" ON "ib_user" ("location");

CREATE UNIQUE INDEX "login" ON "ib_user" ("login");

CREATE UNIQUE INDEX "display_name" ON "ib_user" ("display_name");

--
-- Table: "ib_user_award"
--
CREATE TABLE "ib_user_award" (
  -- Идентификатор
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Идентификатор награжденного пользователя
  "uid" mediumint(8) NOT NULL,
  -- Имя файла с изображением награды
  "file" varchar(255) NOT NULL,
  -- Описание причины для награждения
  "descr" varchar(255) NOT NULL,
  -- Дата награждения
  "time" int(10) NOT NULL
);

CREATE INDEX "uid02" ON "ib_user_award" ("uid");

--
-- Table: "ib_user_contact"
--
CREATE TABLE "ib_user_contact" (
  "uid" mediumint(9) NOT NULL,
  "cid" smallint(6) NOT NULL,
  "value" varchar(80) NOT NULL,
  PRIMARY KEY ("uid", "cid")
);

--
-- Table: "ib_user_contact_type"
--
CREATE TABLE "ib_user_contact_type" (
  "cid" INTEGER PRIMARY KEY NOT NULL,
  -- Название контакта или социальной сети
  "c_title" varchar(80) NOT NULL,
  -- URL значка контакта или социальной сети
  "icon" varchar(255) NOT NULL,
  -- Ссылка на контакт или профиль соцсети
  "link" varchar(255) NOT NULL,
  -- Поле для сортировки
  "c_sort" smallint(6) NOT NULL,
  -- Идентификатор для библиотеки авторизации через соцсети
  "c_name" varchar(32) NOT NULL,
  -- Нужна ли проверка на наличие прав размещать ссылки при выводе этого контакта
  "c_permission" enum(1) NOT NULL DEFAULT '0'
);

--
-- Table: "ib_user_ext"
--
CREATE TABLE "ib_user_ext" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Количество сообщений
  "post_count" int(10) NOT NULL DEFAULT 0,
  -- Суммарный рейтинг
  "rating" float(8,2) NOT NULL DEFAULT 0,
  -- Сумма баллов предупреждений
  "warnings" tinyint(4) NOT NULL DEFAULT 0,
  -- Баланс (сейчас не используется)
  "balance" decimal(10,0) NOT NULL DEFAULT 0,
  -- Если пользователь изгнан, дата окончания срока
  "banned_till" int(10) NOT NULL DEFAULT 0,
  -- Группа прав доступа пользователя
  "group_id" smallint(6) NOT NULL DEFAULT 0,
  -- Дата регистрации
  "reg_date" int(10) NOT NULL DEFAULT 0,
  -- IP, с которого произведена регистрация
  "reg_ip" int(10) NOT NULL DEFAULT 0
);

CREATE INDEX "user_group" ON "ib_user_ext" ("group_id");

--
-- Table: "ib_user_field"
--
CREATE TABLE "ib_user_field" (
-- Comments: 
-- Задаваемые поля для профиля пользователя
--

  -- Идентификатор поля
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Название поля
  "title" varchar(60) NOT NULL,
  -- Тип поля: текст, числовое значение, выбор значения из списка типа Select или переключателей Radio
  "type" enum(11) NOT NULL DEFAULT 'text',
  -- Список возможных значений для select и radio, для text -- регулярное выражение для проверки корректности ввода
  "values" text NOT NULL,
  -- Выводить значение поля при показе сообщений пользователя или только в его профиле
  "in_msg" enum(1) NOT NULL DEFAULT '1',
  -- Поле для сортировки
  "sortfield" smallint(5) NOT NULL
);

--
-- Table: "ib_user_settings"
--
CREATE TABLE "ib_user_settings" (
  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Тем на странице
  "topics_per_page" tinyint(3) NOT NULL DEFAULT 10,
  -- Сообщений на странице
  "posts_per_page" tinyint(3) NOT NULL DEFAULT 20,
  -- Используемый шаблон
  "template" varchar(20) NOT NULL DEFAULT '',
  -- Порядок сортировки сообщений в теме
  "msg_order" enum(4) NOT NULL DEFAULT 'ASC',
  -- Подписка на обновления: нет, только на созданные темы, на все темы, в которых пользователь пишет ответ
  "subscribe" enum(4) NOT NULL DEFAULT 'None',
  -- Часовой пояс участника (смещение в секундах)
  "timezone" smallint(5) NOT NULL DEFAULT 10800,
  -- Показывать подписи
  "signatures" enum(1) NOT NULL DEFAULT '1',
  -- Показывать аватары
  "avatars" enum(1) NOT NULL DEFAULT '1',
  -- Показывать смайлики
  "smiles" enum(1) NOT NULL DEFAULT '1',
  -- Показывать прикрепленные и вставленные изображения
  "pics" enum(1) NOT NULL DEFAULT '1',
  -- Сворачивать длинные сообщения: 0 -- никогда, 1 -- да, 2 -- только  помеченные как флуд
  "longposts" enum(1) NOT NULL DEFAULT '0',
  -- Показывать дату рождения (0 -- нет, 1 -- да, 2 -- только дату, 3 -- только возраст)
  "show_birthdate" enum(1) NOT NULL DEFAULT '3',
  -- Режим рассылки уведомлений
  "subscribe_mode" tinyint(3) NOT NULL DEFAULT 0,
  -- Отправлять полный текст сообщения на почту
  "email_fulltext" enum(1) NOT NULL DEFAULT '1',
  -- Отправлять увеедомления о новых личных сообщениях
  "email_pm" enum(1) NOT NULL DEFAULT '1',
  -- Разрешить отправку сообщений через форму на сайте
  "email_message" enum(1) NOT NULL DEFAULT '1',
  -- Получать рассылки от администратора
  "email_broadcasts" enum(1) NOT NULL DEFAULT '1',
  -- Порог (в процентах), после которого тема считается зафлуженной
  "flood_limit" tinyint(3) NOT NULL DEFAULT 50,
  -- Период (в часах) за который выводятся темы на форуме. 0 -- выдача за все время
  "topics_period" smallint(5) NOT NULL DEFAULT 0,
  -- "Скрытный пользователь" (не показывать в списке присутствующих)
  "hidden" enum(1) NOT NULL DEFAULT '0',
  -- Режим работы визуального редактора: 0 -- выключен, 1 -- вставка тегов без визуализации, 2 -- полностью визуальный (TinyMCE)
  "wysiwyg" enum(1) NOT NULL DEFAULT '1',
  -- Переход после отправки сообщения: 0 -- в тему, 1 -- в раздел, 2 -- к "Обновившимся", 3 -- к "Непрочитанным"
  "goto" enum(1) NOT NULL DEFAULT '0'
);

--
-- Table: "ib_user_value"
--
CREATE TABLE "ib_user_value" (
-- Comments: 
-- Значения задаваемых полей профиля пользователя
--

  -- Идентификатор пользователя
  "uid" mediumint(8) NOT NULL,
  -- Идентификатор задаваемого поля
  "fdid" smallint(5) NOT NULL,
  -- Значение задаваемого поля
  "value" varchar(255) NOT NULL,
  PRIMARY KEY ("uid", "fdid")
);

--
-- Table: "ib_user_warning"
--
CREATE TABLE "ib_user_warning" (
-- Comments: 
-- Предупреждения и наказания пользователей
--

  "id" INTEGER PRIMARY KEY NOT NULL,
  -- Идентификатор пользователя, которому вынесено предупреждение
  "uid" mediumint(8) NOT NULL DEFAULT 0,
  -- Время вынесения
  "warntime" int(10) NOT NULL DEFAULT 0,
  -- Идентификатор модератора, вынесшего предупреждение
  "moderator" mediumint(8) NOT NULL DEFAULT 0,
  -- Идентификатор сообщения, за которое вынесено предупреждение
  "pid" int(10) NOT NULL DEFAULT 0,
  -- Количество штрафных баллов
  "value" tinyint(3) NOT NULL DEFAULT 0,
  -- Дата окончания действия предупреждения
  "warntill" int(10) NOT NULL DEFAULT 0,
  -- Комментарий модератора
  "descr" text NOT NULL
);

--
-- Table: "ib_views"
--
CREATE TABLE "ib_views" (
  -- Номер объекта
  "oid" mediumint(8) NOT NULL,
  -- Для какого объекта указаны просмотры: раздел или тема
  "type" enum(5) NOT NULL DEFAULT 'topic',
  -- Количество просмотров
  "views" int(10) NOT NULL DEFAULT 0,
  PRIMARY KEY ("oid", "type")
);

--
-- Table: "ib_vote"
--
CREATE TABLE "ib_vote" (
-- Comments: 
-- Результаты голосования отдельных пользователей
--

  -- Номер темы с опросом
  "tid" mediumint(8) NOT NULL,
  -- Идентификатор пользователя
  "uid" mediumint(8) NOT NULL,
  -- Идентификатор варианта ответа
  "pvid" int(10) NOT NULL,
  -- Время голосования
  "time" int(10) NOT NULL,
  -- IP, с которого производилось голосование
  "ip" int(10) NOT NULL,
  PRIMARY KEY ("tid", "uid")
);

COMMIT;
