<?php
/** ================================
 *  @package IntBPro
 *  @author 4X_Pro <admin@openproj.ru>
 *  @version 3.0
 *  @copyright 2007,2010, 2012-2013 4X_Pro, INTBPRO.RU
 *  Intellect Board Pro
 *  Библиотека для работы с локальной поисковой системой Sphinx
 *  ================================ */

class Library_sphinx extends Library {
  function search_posts($text,$fids,$cond) {
    require_once(BASEDIR.'opt/Sphinx/sphinxapi.php');
    
    $server=Library::$app->get_opt('search_sphinx_server');
    if (!$server) $server = 'localhost';
    $port = Library::$app->get_opt('search_sphinx_port');
    if ($port) $port = '9312';
    $cl = new SphinxClient();
    $cl->SetServer($server, $port);
    
    $cl->SetFilter('fid', $fids );
    if (!empty($cond['start_date']) && !empty($cond['end_date'])) $cl->SetFilterRange('postdate',$cond['start_date'],$cond['end_date']);
    if (!empty($cond['value'])) $cl->SetFilter('value', $cond['value'] );

    $result = $cl->Query($text,'idx_intb_post'); // поисковый запрос
    if ( $result === false ) {
      _dbg("Ошибка поиска: ".$cl->GetLastError()); // выводим ошибку если произошла
    }
    else {
      $warning = $cl->GetLastWarning();
      if ($warning) _dbg($warning);
      return $result['matches']; // возвращаем только PIDы найденных сообщений, остальное нам не нужно
    }
  }
  
  function search_topics($text,$fids,$cond) {
   require_once(BASEDIR.'opt/Sphinx/sphinxapi.php');
    
   $server=Library::$app->get_opt('search_sphinx_server');
   if (!$server) $server = 'localhost';
   $port = Library::$app->get_opt('search_sphinx_port');
   if ($port) $port = '9312';
   $cl = new SphinxClient();
   $cl->SetServer($server, $port);
    
   $cl->SetFilter('fid', $fids );
//   if (!empty($cond['start_date']) && !empty($cond['end_date'])) $cl->SetFilterRange('postdate',$cond['start_date'],$cond['end_date']);
//   if (!empty($cond['value'])) $cl->SetFilter('value', $cond['value'] );
  
   $result = $cl->Query($text,'idx_intb_topic'); // поисковый запрос
   if ( $result === false ) {
    _dbg("Ошибка поиска: ".$cl->GetLastError()); // выводим ошибку если произошла
   }
   else {
    $warning = $cl->GetLastWarning();
    if ($warning) _dbg($warning);
    return $result['matches']; // возвращаем только TIDы найденных тем, остальное нам не нужно
   }
  }  
}